/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "cvslog-function.h"
//#include <sys/xattr.h>
#include <iostream>



cvslog_function::cvslog_function ()
: ctl_function ()
{
}



bool cvslog_function::execute (int &argc, char *argv[])
{
  if (argc < 3)
  {
    help ();
    
    return false;
  }

  if (!display_log (argv[2]))
    std::cout << "No log available !" << std::endl;
  
  return true;
}



void cvslog_function::help () const
{
  std::cerr << "Display the last CVS log for the file given." << std::endl
            << std::endl
	    << "Command:" << std::endl
	    << "  cvsfsctl cvslog <path>" << std::endl;
}
