/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_COMMAND_ADD_H__
#define __CVS_COMMAND_ADD_H__

#include "cvs-command.h"

// forward references
class cvs_directory_entry;



class cvs_command_add : public cvs_command
{
  public:
    cvs_command_add (const std::string &, const std::string &, cvs_directory_entry &);

    virtual bool run (cvs_session &);

  private:
    bool send_prepare_command (cvs_session &);
    bool send_command (cvs_session &);
    virtual bool process_line (cvs_session &, const std::string &);

    std::string item_path;
    std::string item_comment;
    cvs_directory_entry &item_entry;
};



#endif
