/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_COMMAND_H__
#define __CVS_COMMAND_H__

#include <string>

// forward references
class cvs_session;



class cvs_command
{
  public:
    cvs_command ();
    virtual ~cvs_command ();

    virtual bool run (cvs_session &) = 0;

  protected:
    virtual bool process_response (cvs_session &);
    virtual bool process_line (cvs_session &, const std::string &) = 0;
    virtual bool establish_logging (cvs_session &);
    
    std::string filename;
};



#endif
