/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "cvs-connection-factory.h"
#include "cvs-pserver-connection.h"



cvs_connection_factory *cvs_connection_factory::fInstance = 0;



cvs_connection_factory::cvs_connection_factory ()
{
}



cvs_connection_factory *cvs_connection_factory::instance ()
{
  if (!fInstance)
    fInstance = new cvs_connection_factory ();

  return fInstance;
}



cvs_connection *cvs_connection_factory::get_connection (CONNECTION_TYPE type,
							const std::string & server,
							const std::string & port,
							const std::string & root,
							const std::string & project,
							const std::string & userid,
							const std::string & password)
{
  switch (type)
  {
    case PSERVER:
    {
      cvs_pserver_connection *conn = new cvs_pserver_connection (userid, password, server, port, root, project);
      
      // pserver allows us to connect ?
      if (!conn->test ())
      {
        delete conn;
	return 0;
      }
      
      return conn;
    }
  }

  return 0;
}
