/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_LOADTREE_THREAD_H__
#define __CVS_LOADTREE_THREAD_H__

#include <string>
#include "thread.h"
#include "condition.h"
#include "sema.h"
#include "cvs-directory-entry.h"

// forwardx references
class cvs_connection;



class cvs_loadtree_thread : public thread
{
  public:
    cvs_loadtree_thread (cvs_connection &, cvs_directory_entry &, const std::string &);
    virtual ~cvs_loadtree_thread ();

    void request_termination () { terminate.signal (); }

  private:
    virtual void run ();

    cvs_connection *connection;
    cvs_directory_entry root;
    std::string label;
    time_t last_update;
    double last_duration;
    condition terminate;
    semaphore terminate_completed;
    bool running;
};



#endif
