/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_PSERVER_CONNECTION_H__
#define __CVS_PSERVER_CONNECTION_H__

#include <string>
#include "cvs-connection.h"

// forward references
class cvs_pserver_session;



class cvs_pserver_connection : public cvs_connection
{
  public:
    cvs_pserver_connection (const std::string &, const std::string &, const std::string &,
			    const std::string &, const std::string &, const std::string &);
    cvs_pserver_connection (const cvs_pserver_connection &);
    virtual ~cvs_pserver_connection ();

    virtual cvs_connection *clone ();

    virtual bool test ();

    virtual bool execute_command (cvs_command &);

  private:
    bool login (cvs_pserver_session *&);

    cvs_pserver_session *establish_connection ();
    void close_connection (cvs_pserver_session *&);
    bool do_test (cvs_pserver_session *);
    bool do_login (cvs_pserver_session *);

    std::string cvs_userid;
    std::string cvs_password;
};



#endif
